%{
/*#define YYSTYPE double*/
double mem[26];
%}
%union {
   double val;
   int index;
}
%token <val> NUMBER
%token <index> VAR
%type <val> expre
%right '='
%left '+' '-'
%left '*' '/'
%left UNARYMINUS
%%
lista: 
     | lista '\n' 
     | lista error '\n' {yyerrok;}
     | lista expre '\n' { printf("\t%lf\n",$2); }
     ;
expre: NUMBER                     { $$ = $1; }
     | VAR                        { $$=mem[$1];}
     | VAR '=' expre              { $$=mem[$1]=$3;}
     | expre '+' expre            { $$ = $1 + $3; }
     | expre '-' expre            { $$ = $1 - $3; }
     | expre '*' expre            { $$ = $1 * $3; }
     | expre '/' expre { 
                         if ($3==0.0) execerror("Division por cero","");
                         $$ = $1 / $3; 
                       }

     | '(' expre ')'              { $$ = $2; }
     | '-' expre %prec UNARYMINUS { $$ = -$2; }
     ;
%%
#include <stdio.h>
#include <ctype.h>

char *nom_prog;
int num_lineas=1;

main(int argc,char *argv[]) {
   nom_prog=argv[0];
   yyparse();
}

execerror(char *s,char *t) {
  warning(s,t);
  exit(1);
}

fpecatch() {
  execerror ("Error de punto flotante",(char *)0);
}
 
yylex() {
int c;
   while ((c=getchar())==' '||c=='\t');
   if (c==EOF) return 0;
   if (c=='.'||isdigit(c)) {
       ungetc(c,stdin);
       scanf("%lf",&yylval.val);
       printf("Token numero: %lf\n",yylval.val);
       return NUMBER;
   }
   if (islower(c)) {
       yylval.index=c-'a';
       printf("Token variable: %c\n",c);
       return VAR;
   }
   if (c=='\n') num_lineas++;
   printf("Token caracter: %c\n",c);
   return c;
}

warning(char *s,char *t) {
   fprintf(stderr,"%s: %s",nom_prog,s);
   if (t) fprintf(stderr," %s",t);
   fprintf(stderr," cerca de la linea %d\n",num_lineas);
}

yyerror(char *s) {
   warning(s,(char *)0);
}
